
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>小钢的架构思考:架构设计 / 憋错料</title>

    <meta name="description" content="小钢的架构思考:架构设计 原创文章,转载请注明:转载自Keegan小钢并标明原文链接:http://keeganlee.me/post/architecture/20160621微信订阅号:keeganlee_me写于2016-06-21 小钢的架构思考:什么是架构小钢的架构思考:架构规划小钢的架构思考:架构设计 最近一个多月因为忙于工作上的项目重构,所以文章一直没能更新.现在,重构终于暂时告一段落,于是,赶紧抽时间把文章写完更新发布.下面进入正文. 当架构规划的结果,整理出一堆不同优先级的需求,尤其是质量需求之后,接下">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">小钢的架构思考:架构设计</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>原创文章，转载请注明：转载自<a href="http://keeganlee.me/" rel="external nofollow noreferrer">Keegan小钢</a><br />并标明原文链接：<a href="http://keeganlee.me/post/architecture/20160621" rel="external nofollow noreferrer"><strong>http://keeganlee.me/post/architecture/20160621</strong></a><br />微信订阅号：<strong>keeganlee_me</strong><br />写于2016-06-21</p>
<hr />
<br /><a href="http://keeganlee.me/post/architecture/20160425" rel="external nofollow noreferrer">小钢的架构思考:什么是架构</a><br /><a href="http://keeganlee.me/post/architecture/20160509" rel="external nofollow noreferrer">小钢的架构思考:架构规划</a><br /><a href="http://keeganlee.me/post/architecture/20160621" rel="external nofollow noreferrer">小钢的架构思考:架构设计</a></p>
<hr />
<br />最近一个多月因为忙于工作上的项目重构，所以文章一直没能更新。现在，重构终于暂时告一段落，于是，赶紧抽时间把文章写完更新发布。下面进入正文。</p>
<hr />
<br />当<a href="http://keeganlee.me/post/architecture/20160509" rel="external nofollow noreferrer">架构规划</a>的结果，整理出一堆不同优先级的需求，尤其是质量需求之后，接下来就要思考如何才能最大限度地实现这些需求，这就是架构设计要解决的问题。那么，如何进行架构设计呢？设计到什么程度才合适呢？我从架构思维和架构原则方面来思考架构设计的问题。</p>
<h2>架构思维</h2>
<p>这里说的架构思维是指进行架构设计时最高层级的思考方式，比如：面向过程、面向对象、面向切面、面向服务等。</p>
<blockquote><h3>面向过程(Procedure Oriented)</h3>
</blockquote>
<p>面向过程的设计思路就是将问题分解成一个个步骤，按照步骤一步步执行之后，问题就解决了。每一个步骤就是一个子过程，也可以称为一个模块，子过程还可以继续拆分成更多更细的子过程。因此，面向过程的设计核心就是过程分析、功能分解，一般采用自顶向下、逐步求精的分解方式。一个大的程序可以分解成多个子程序，子程序再分解成多个大模块，大模块再分解成多个小模块，最终分解成一个个函数。</p>
<p>在此我想借用一个象棋对战的例子，例子来源于一篇很老的文章：<a href="http://blog.csdn.net/wanghao72214/article/details/3961250" rel="external nofollow noreferrer">架构师之路(4)---详解面向对象</a>。以下是采用面向过程的设计思路分解的对战流程图：<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAva2VlZ2FubGVlLm1lL2FyY2hpdGVjdHVyZS9faW1hZ2UvMjAxNjA2MjEvMTMtNDYtNTQuanBn.jpg" /><br />将以上每个流程分别用函数实现，问题就解决了。</p>
<p>面向过程的优点主要有两个：一是流程清晰简单；二是性能比较高。尤其是性能，这也是为什么至今很多单片机开发、驱动程序开发、或其他与硬件相关的系统开发等对性能要求很高的软硬件程序依然在用面向过程的方式进行设计和开发。</p>
<p>面向过程的缺点也很明显：一是主程序太重，主程序与模块承担的任务不均衡；二是函数不易扩展，导致其可扩展性、可复用性、可维护性相对都比较差；三是上下层级模块之间的联系太紧密，耦合高，所以模块也难以复用。</p>
<blockquote><h3>面向对象(Object Oriented)</h3>
</blockquote>
<p>面向过程的思路是&ldquo;怎么做&rdquo;，关注于实现细节；而面向对象的思路是&ldquo;谁来做&rdquo;，关注于抽象的对象。对象的封装、继承和多态等特性，让我们以更接近现实世界的方式来思考程序设计。面向对象相比面向过程容易实现更好的分离，相应地可扩展性、可复用性、可维护性也会比较高，但同时会牺牲掉一些性能。不过，也因为硬件发展迅猛，所以牺牲的那点性能也不算什么了。</p>
<p>面向对象设计的难点在于抽象，从问题域中抽象出一个个对象，并找出它们之间的关系。好在有SOLID原则和一大堆设计模式指导我们如何更好地设计。也有领域驱动设计的方法论指导我们怎么进行领域建模。</p>
<p>还是象棋对战的例子，用面向对象的设计思路，可以抽象出以下三种对象：</p>
<ol>
<li>棋手：负责行棋，红黑两方行为一致。</li>
<li>棋盘：负责绘制棋盘画面。</li>
<li>裁判：负责判定吃子、犯规和输赢等。</li>
</ol>
<p>三者关系如下图：<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAva2VlZ2FubGVlLm1lL2FyY2hpdGVjdHVyZS9faW1hZ2UvMjAxNjA2MjEvMTMtNTYtNTMuanBn.jpg" /><br />棋手对象行棋后，棋盘对象根据棋子布局的变化刷新棋盘画面，裁判对象则对棋局进行判定。</p>
<blockquote><h3>面向切面(Aspect Oriented)</h3>
</blockquote>
<p>面向切面，也就是AOP，是对面向对象的一种扩展，为了弥补面向对象的局限性。面向对象设计主要是对业务领域进行抽象封装，但对于业务领域之外的内容，比如日志记录、权限检查、事务支持等，在没有AOP之前，只能将实现这些功能的代码散布在所有对象层次中，但这些代码与所散布的对象的核心业务功能是没任何关系的。这种做法也导致了大量重复的代码，而且难以复用。AOP就是为了解决这种问题而产生的，将这些与业务领域无关的部分分离出来，以横切面的方式注入系统，从而减少重复代码、减低耦合度、增强扩展性和维护性。</p>
<p>将日志记录、权限检查、事务支持等等使用横切技术分别独立成一个个服务模块，这些模块也称为&ldquo;横切面&rdquo;，这样就可以将这些与业务无关的服务从业务核心中解耦出来，就可以将系统划分为两部分：业务核心和通用服务。业务核心依然采用面向对象的思路去设计，而通用服务则可以采用面向切面的思想来实现。</p>
<p>Spring就大量使用了AOP技术，OkHttp的Interceptor也是AOP设计的一种实现。很多场景都可以使用AOP的思想去设计，比如添加统一的Http Request Header，添加统一的登录验证，添加统一的缓存，添加统一的错误处理，等等，只要是通用的功能点基本都可以使用AOP的思想去设计和实现。</p>
<blockquote><h3>面向服务(Service Oriented)</h3>
</blockquote>
<p>不管是SOA还是现在流行的微服务架构，都是采用面向服务的思维方式。说到面向服务，需要先了解一个概念：<strong>Monolith</strong>，也称为单体架构。在没有SOA思想之前，软件系统将所有功能整合成一个独立的软件包，然后部署在单一的平台上。比如，在J2EE平台，一个软件系统最终会打成一个包含所有功能的WAR包，然后部署到Web容器中。若要扩展的话，则通过复制这个WAR包部署到多个Web容器来实现。这种方式，如果程序需要改动，不管多么微小的改动，都需要重新打包个新的WAR包，并替换掉所有Web容器的旧WAR包。</p>
<p>面向服务的架构思想则是，将系统的不同功能分离成一个个单独的应用程序或组件，统称为服务，不同服务部署在不同容器中，不同服务之间通过一些轻量级的交互机制来通信，如HTTP，RPC等。这样，相比单体架构，功能服务之间明显是松耦合的，扩展也会灵活很多。而且，不同服务还可以用不同编程语言实现，部署到不同平台。</p>
<p>不管是面向过程，面向对象，面向切面，还是面向服务，最本质的区别还是在于看问题的角度不同。而在实际应用中，也不会只使用一种架构思维，而是综合考虑的，系统的不同方面或不同层级可能会用不同的架构思维去思考。比如，一个庞大的复杂系统，整体上可能用面向服务的架构思维去拆解各种服务，业务核心方面的服务可能再用面向对象的架构思维进行建模，通用功能服务还是用面向切面的架构思维来设计，事务流程当然是采用面向过程的架构思维最直观。</p>
<h2>架构原则</h2>
<p>架构思维从面向过程，到现在的面向服务，以后也不知道还会出现什么新的思维方式。但无论是何种思维方式，都存在一些共通性的架构原则，可以指导我们如何设计出一个合适的架构。从另一方面来说，架构设计，不管是面向过程、面向对象、面向切面，还是面向服务，无一例外，主要都是在对复杂的系统进行分解。那么，相应地，就需要思考三个问题：分解为哪些？如何分解？分解到什么程度？相对应地，有三个重要原则可以分别为解答这三个问题提供指引。</p>
<blockquote><h3>关注点分离原则</h3>
</blockquote>
<p>关注点分离原则主要就是为了解决将复杂系统分解为哪些部分的问题，分解出来的部分就是关注点。过程、对象、切面、服务，只是分解的角度（也是关注点）不同而已。将复杂的问题根据不同的关注点分解为多个相对简单的问题，再对每个简单的问题进行分别处理，这就是关注点分离。分离之后，各个关注点相对独立，每个关注点的变化基本不会影响到其他的关注点，即使需要改变，改变的部分也很小。需要扩展时，影响也将会最小化。</p>
<p>关注点分离，最难的在于如何识别出有哪些关注点。要识别出有哪些关注点，需要将复杂系统不同的方方面面抽象成一个个具有清晰明确的边界的概念模型，或为&ldquo;对象&rdquo;，或为&ldquo;组件&rdquo;，或&ldquo;切面&rdquo;，或&ldquo;服务&rdquo;，以将复杂问题分解为一个个相对简单的问题。</p>
<p>从不同维度，可以有不同的分离方案。除了上面提到的面向过程、面向对象、面向切面、面向服务等思维角度之外，还有如下图所示的其他几种不同维度，该图引自《软件架构设计》一书中的【<strong>2.1.1 关注点分离之道</strong>】一节：<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAva2VlZ2FubGVlLm1lL2FyY2hpdGVjdHVyZS9faW1hZ2UvMjAxNjA2MjEvMjMtMDktMTEuanBn.jpg" /><br />上图分别从功能职责、通用性、大小粒度的不同维度进行分离。从职责维度进行分离，就可以分为三层架构：展现层、业务层、数据层，相应的关注点就是：数据展示、数据加工、数据管理。另外，数据层还可以再分离为网络层和缓存层。从通用性维度来看，就可以分离出技术通用部分、领域通用部分、特定应用部分。一般，使用框架技术就可以用于分离各种不同的通用部分。从大小粒度的维度考虑，无非就是将复杂系统分离为各个子系统，再分离为不同模块，再细分到不同类。</p>
<p>在实际应用中，并不会只采用一种维度，而是多种维度综合考虑，不同部分采用不同维度的分离方案。比如，也许，整体上按职责分离为多层架构，然后，在某些层级根据大小粒度再进行分离，例如将业务层按照不同业务模块进行分离。另外，也会将不同的通用部分进行分离，例如可将技术通用部分的日志记录、领域通用部分的权限检查分别分离出来。</p>
<p><a href="http://www.educity.cn/blog/user2/51639/archives/2009/41580.html" rel="external nofollow noreferrer">《架构就是关注点分离》</a>这篇文章则描述了更多关注点分离的例子。</p>
<blockquote><h3>高内聚低耦合原则</h3>
</blockquote>
<p>系统应该如何分解？或者说关注点应该如何分离？高内聚低耦合原则就可以为该问题提供设计指引。</p>
<p>内聚是指模块内部的功能和元素之间的紧密程度，而耦合则是指模块与模块之间的关联程度。</p>
<p>内聚可分为好多种：功能内聚、顺序内聚、通信内聚、过程内聚、时间内聚、逻辑内聚、偶然内聚。功能内聚是最强最好的内聚，模块内各元素共同协作完成一个单一的功能，这些元素紧密联系、缺一不可。顺序内聚则是指，模块中各个处理元素和同一个功能密切相关，而且这些处理必须顺序执行，通常前一个处理元素的输出时后一个处理元素的输入。顺序内聚的内聚度也比较高，但相比功能内聚，缺点就是可维护性相对差些。偶然内聚则是最弱的内聚，模块内的各元素之间没有任何联系，只是偶然地被凑到一起。</p>
<p>耦合也分为好多种：非直接耦合、数据耦合、标记耦合、控制耦合、外部耦合、公共耦合、内容耦合。非直接耦合表示两个模块之间没有直接关系，它们之间的联系完全是通过主模块的控制和调用来实现的，其耦合度是最弱的，模块独立性最强。数据耦合表示调用模块和被调用模块之间只传递简单的数据项参数，相当于高级语言中的值传递。标记耦合也称为特征耦合，表示调用模块和被调用模块之间传递的不是简单数据，而是数据结构，像高级语言中的数据名、记录名和文件名等数据结果，这些名字即为标记，其实传递的是地址。控制耦合则表示模块之间传递的不是数据信息，而是控制信息例如标志、开关等，一个模块控制了另一个模块的功能。外部耦合则是指一组模块都访问同一全局简单变量，而且不通过参数表传递该全局变量的信息。内容耦合则是一个模块直接访问另一模块的内容，这是最强的耦合。</p>
<p>高内聚的设计原则是说：一个模块只完成一个单一的功能，尽可能使模块达到功能内聚。<br />低耦合的设计原则是说：若模块间必须存在耦合，应尽量使用数据耦合，少用控制耦合，慎用或有控制地使用公共耦合，并限制公共耦合的范围，尽量避免内容耦合。</p>
<blockquote><h3>适度设计</h3>
</blockquote>
<p>适度设计原则关注的就是系统分解到什么程度的问题。适度设计就是指设计不要过度，也不要不足。那么，怎样才算设计过度？怎样才算设计不足？一句话，设计过度就是想太多，设计不足就是想太少。感觉好虚，是吧？我也这么觉得。因为，如何判断一个设计是否过度或不足，并没有标准的可量化指标。因此，设计是否适度，更多在于主观的判断。而如何避免设计过度或不足，更多的也在于个人经验积累所形成的直觉。</p>
<p>设计不足相对还比较容易判断，导致设计不足的原因主要有两个：一是因为新手的设计经验不足而导致；二是因为一味追求快速实现产品功能而跳过或大幅度减少了设计而导致。</p>
<p>也有些设计过度比较明显的例子，比如Uncle Bob提出的Clean架构，每个关注点都有着清晰明确的边界，架构真的很清晰，可维护性、可测试性都非常不错，高内聚低耦合。但是，如果将其应用到一个只有两三个开发人员的小团队的小项目中，就会明显发现代码量大而且复杂，每需要添加一个小功能，却需要编写大量代码。这对一个小团队小项目来说，明显不适合。Clean架构比较适用于人员较多的团队，和中大型项目。</p>
<p>因此，判断设计是否适度，不能脱离团队和项目的现状。另外，还有其他现状因素，包括各种商业需求、功能需求和质量需求。大部分情况下，形成过度设计的原因在于：一是过多地考虑了未来可能发生的变化；二是为了追求设计而设计。适度设计，首先应该着眼于当下，当下的需求、当下的开发成本、当下的人员和项目现状；其次才是适当考虑如何应对未来的变化。对于未来的变化，也不是任何可能都要考虑，只需考虑在可预见的未来里有非常大的几率会发生的变化即可，这个非常大的几率可以达到90%以上。比如，已经确定要实现的需求，只是因为优先级问题而稍微延后；比如，已经确定的人员扩充计划；比如，双11要搞活动，交易量将会激增；等等。</p>
<p>也就是说，适度设计的原则，可以总结为：设计应该优先满足当前确定的需求，再满足可预见未来里几乎可以确定会发生的需求。只满足当前需求而不考虑未来，就容易导致设计不足；而过多地考虑未来可能发生的需求，就容易导致设计过度。因此，适度设计需要在当前需求和未来需求之间做好平衡，而我觉得只考虑当前需求和未来几乎确定会发生的需求是最好的平衡点。</p>
<h2>写在最后</h2>
<p>本来计划还想再谈谈架构风格，比如分层架构、MVC\MVP\MVVM、RESTFul、Clean架构等等。但因为这篇文章的进度已经拖了一个多月，不能再拖了。因此，决定本文就此收手，那些架构风格以后有机会再讲吧。</p>
<hr />
<br />扫描以下二维码即可关注订阅号。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-12 04:54:06 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>小钢的架构思考:架构设计的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xBdqD4.html" rel="bookmark">大型网站技术架构&mdash;&mdash;网站架构的伸缩性设计</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先,所谓网站的伸缩性,指不需要改变网站的软硬件设计,仅仅通过改变部署的服务器数量就可以扩大或者缩小网站的服务处理能力.在整个互联网行业的发展渐进演化中,最重要的技术就是服务器集群,通过不断地向集群中添加服务器来增强整个集群的处理能力. 一.网站架构的伸缩性设计 1.1 不同功能进行物理分离实现伸缩 (1)纵向分离:将业务处理流程上得不同部分分离部署,实现系统的伸缩性: (2)横向分离:将不同的业务模块分离部署,实现系统的伸缩性: 1.2 单一功通过集群规模实现伸缩 使用服务器集群,即将相同服务			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZQz6l0.html" rel="bookmark">&lbrack;实用&rsqb; 为app提供api，架构该怎么设计，需要考虑高并发，访问量比较大</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为app提供api,架构该怎么设计,需要考虑高并发,访问量比较大 引用:http://zhidao.baidu.com/link?url=D_TRx6MlKqEz9Lxw7Yd58Nb53MGiKtfsKdvwRHseod4lFKd6iy0WXVrDX6VLe2rubklVpS9EjjE5BZ3U5UjkcBJvhfUWS5p0bQvLPWeBxHW 2015-04-13 21:58 提问者采纳 1.关于rest,仅仅是一种风格,至于框架,spring mvc 是比较成熟的,其实这块mvc 框架			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jwdpg3.html" rel="bookmark">58同城沈剑：好的架构不是设计出来的，而是演进出来的</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对 很多创业公司而言,随着业务的增长,网站的流量也会经历不同的阶段.从十万流量到一百万流量,再从一百万流量跨越到一千万甚至上亿的流量,网站的架构需要 经历哪些变化?我们一起听听 58 同城的技术委员会执行主席沈剑在 OneAPM 技术公开课上的回答(以下演讲整理): 本场演讲我主要阐述一下,58同城从小流量.中等规模流量.大流量,到更大的流量过程中,架构是怎么演进的?遇到了哪些问题?以及如何解决这些问题? 好的架构不是设计出来的而是演进出来的 对很多创业公司而言,在初期的时候,我们很难在初期就预			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eZVmg3.html" rel="bookmark">我们来梳理下Kubernetes生产架构，其设计适用于绝大多数环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先,我们来梳理下Kubernetes生产架构,其设计适用于绝大多数环境.如下图所示 在该架构中,我们可以将其分为四层,如下: Client层:即Kubernetes集群外部用户.客户端等: 服务访问层:即由Traefik ingress实现服务发现.负载均衡和路由规则定义等: 业务应用层:即基于Kubernetes平台构建和运行企业业务应用,如CI/CD持续集成.微服务项目.监控告警和日志管理.私有镜像仓库等服务: 基础设施层:即由Kubernetes容器管理平台和Ceph数据持久化存储等系统			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/NMygLj3.html" rel="bookmark">中文翻译为&amp;quot&semi;具象状态传输&amp;quot&semi;的RESTful的架构风格和设计思想</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文标签:  具象状态传输 RESTful架构 RESTful理解 REST   服务器 REST 定义了一组体系架构原则,您可以根据这些,包括使用不同语言编写的客户端如何通过 HTTP 处理和传输资源状态.所以在事实上,REST 对 Web的影响非常大,由于其使用相当方便,已经普遍地取代了基于 SOAP 和 WSDL 的接口设计.在多年以后的今天,REST的主要框架已经开始雨后春笋般的出现. REST(Representational State Transfer ),有中文翻译为&quot;具象状态传			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0awxlP4.html" rel="bookmark">实战开发农商O2O在线交易系统&mdash;架构及数据库设计</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本课程主要介绍实战开发O2O在线交易系统-架构及数据库设计为主题,主要从系统开发背景,系统分析,可行性分析,功能结构图,数据库结构图进行分别讲解,主要对数据库进行ER图的表实体设计同时对于代码块中的公共类.拦截器,以及接口和接口实现类进行开发.在本课程中最主要还是对系统的架构设计,以及运行流程进行图形化讲解. 课程目录:第1课时开发背景及系统分析第2课时系统流程结构图设计(1)第3课时系统功能结构图第4课时数据库表的设计第5课时系统流程结构E-R图设计第6课时Mysql数据库开发第7课时产品主类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDZxmo3.html" rel="bookmark">atitit&period;系统架构图 的设计 与工具 attilax总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				atitit.系统架构图 的设计 与工具 attilax总结 1. 架构图的4个版式(标准,(左右)悬挂1 2. 架构图的层次结构(下属,同事,助手)1 3. wps ppt1 4. 使用EDraw画系统架构图2 5. 系统架构常用软件: 1. MindManager 画思维导图 2. Microsoft Office Visio 内有uml建模工具, 上图也可以用此软件画出来 3. Axure RP Pro 可以用来画产品原型2 6. Smartdraw_百度百科2 1. 架构图的4个版式(标			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mzr17dM.html" rel="bookmark">基于HBASE的并行计算架构之rowkey设计篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.大数据在HBASE存储.计算以及查询的应用场景 海量数据都是事务数据,事务数据都是在时间的基础上产生的.数据的业务时间可能会顺序产生,也可能不会顺序产生,比如某些事务发生在早上10点,但是在下午5点才结束闭并生成出来,这样的数据就会造成存储加载时的时间连续性.另外海量数据的挖掘后产生的是统计数据,统计数据也有时间属性,统计数据如果进行保存必须保证在统计计算之后数据尽量不再变化,如果统计发生后又有新的事务数据产生,那么将重新触发统计计算然后重新保存覆盖原有已经存储的数据.其它数据则主要是以配置			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41aRog4.html" rel="bookmark">迈向大数据架构师 - 架构师转型方法与架构设计理论</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				迈向大数据架构师 - 架构师转型方法与架构设计理论课程学习地址:http://www.xuetuwuyou.com/course/233课程出自学途无忧网:http://www.xuetuwuyou.com课程摘自&lt;大数据系统架构分析师成长之路&gt;:http://www.xuetuwuyou.com/course/200 1.课程目标通过本课程的学习,让学员了解到什么是系统架构师,什么大数据系统架构师,两者的区别与联系,程序员与架构师的不同,程序员如何向架构师转型,一个架构师工作日常及必须修炼的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0d5gw3.html" rel="bookmark" class="title">HBase学习</a>
					<div>
						记录HBase的学习过程.之后会陆续添加内容. 读取hbase的博客,理解hbase是什么.推荐博文: 1,HBase原理,基础架构,基础概念 2,HBase超详细介绍 --------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q5GxG3.html" rel="bookmark" class="title">HDU 2489 Minimal Ratio Tree（最小生成树）</a>
					<div>
						该题就是最小生成树算法的变形,由于这个比值没有什么规律,不可能一下子算出最小情况,我们可以很容易发现,结点数非常少,所以我们可以枚举出m个结点的所有组合,这样,结点权值只和就确定了,为了使得比值最小, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n1mbNM.html" rel="bookmark" class="title">iOS协议、代理、Block和回调、类别</a>
					<div>
						[协议](Protocol) //协议是用来规范接口,实现对象间交互的一种机制.类似于JAVA中的接口,可以模拟. 协议的权限 @optional//可选的 @required//必须的 [代理] 一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vZbbj3.html" rel="bookmark" class="title">shell脚本编程之循环语句</a>
					<div>
						在运行脚本时重复执行一系列的命令是很常见的,这时我们就需要使用循环语句来达到这个目的. 一.for命令 格式:for 变量 in 列表:do 循环体 done for命令会遍历列表中的每一个值,并且在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGJ9l0.html" rel="bookmark" class="title">&lbrack;leedcode 118&rsqb; Pascal&amp;&num;39&semi;s Triangle</a>
					<div>
						Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Retur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0leNDE3.html" rel="bookmark" class="title">eclipse配置步骤</a>
					<div>
						1.windows-preferences-Server-Runtime Environments 2.&quot;Add&quot;按钮,选择Tomcat v6.0 3.Tomcat install ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWDGWk0.html" rel="bookmark" class="title">Nexus私服使Maven更加强大</a>
					<div>
						前边简单介绍了Maven,而Maven默认提供的中央仓库是在远程网络服务Appache提供的,这对于我们开发时不合理的.如果我们没网了或者什么情况,我们怎么办?也就是说我们队中央仓库的依赖性太大.而N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLBxW3.html" rel="bookmark" class="title">IIS中Log无法生成解析</a>
					<div>
						1. 来源: 最近,给客户作了一次服务器更新. 随后一周,客户因操作失误,需要调查不当操作,因此得检查系统的Log文件,发现自从发布后,再也没有看到新生成的Log文件. 2. 分析过程: 2.1 第一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymgwAM.html" rel="bookmark" class="title">【转载】tomcat部署web项目的3中方法</a>
					<div>
						转载自:http://blog.csdn.net/wjx85840948/article/details/6749964/ 1.直接把项目复制到Tomcat安装目录的webapps目录中,这是最简单的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPdNy4.html" rel="bookmark" class="title">前端基础之人物介绍页面</a>
					<div>
						先上效果图: css代码: 1 h1{ 2 font-size: 50px; 3 font-family: Georgia; 4 } 5 h2{ 6 font-size: 30px; 7 } 8 #c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3waWmjM.html" rel="bookmark" class="title">【j2ee spring】29、巴巴运动网-整合hibernate4&plus;spring4&lpar;4&rpar;DAO层</a>
					<div>
						巴巴运动网-整合hibernate4+spring4(3)DAO层 1.项目图解 2.首先我们引入相应的jar包 3.我们配置一下数据库中相应的实体对象 ProductType.java /** *  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzkBbl0.html" rel="bookmark" class="title">&lbrack;js高手之路&rsqb;Node&period;js&plus;jade&plus;mongoose实战todolist&lpar;分页&comma;ajax编辑&comma;删除&rpar;</a>
					<div>
						该系列文章索引: [js高手之路]node js系列课程-创建简易web服务器与文件读写 [js高手之路]node js系列课程-图解express+supervisor+ejs用法 [js高手之路] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jrZOE0.html" rel="bookmark" class="title">Mysql基本语句的总结</a>
					<div>
						1---------------创建一个表------------------------------------ drop table if exists 表名 create   table 表名( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RjQgv0.html" rel="bookmark" class="title">PHP封装一个上传类</a>
					<div>
						&lt;?php //print_r($_FILES['pic']); //print_r($_SERVER); header(&quot;Content-type:text/html; charse ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDlpznM.html" rel="bookmark" class="title">51SAP公开课开讲之SAP FICO模块</a>
					<div>
						SAP 是全球企业管理软件与解决方案的技术领袖,同时也是市场领导者.30余年来,通过其应用软件.服务与支持,SAP持续不断向全球各行业企业提供全面的企业级管理软件解决方案.随着以SAP为代表的新一代商 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mzn2bkM.html" rel="bookmark" class="title">iOS学习之集合</a>
					<div>
						NSArray NSArray是一个Cocoa类,是用来存储对象的有序列表的,可以在有序列表中存放任意类型的对象. NSArray有两个限制,首先是只能存储Objective-c对象,而不能存储原始的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLqQGy0.html" rel="bookmark" class="title">Android中验证输入是否为汉字及手机号，邮箱验证，IP地址可用port号验证</a>
					<div>
						1,验证是否为汉字 // 验证昵称 private boolean verifyNickname() { String nickname = edt_username.getText().toStri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLq9Kk0.html" rel="bookmark" class="title">&lbrack;spring源码学习&rsqb;-BeanPostProcessor的使用</a>
					<div>
						一.接口描述 spring提供了一个接口类-BeanPostProcessor,我们叫他:bean的加工器,应该是在bean的实例化过程中对bean做一些包装处理,里边提供两个方法 public in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JRVpb4.html" rel="bookmark" class="title">【模拟试题2】【20150520】</a>
					<div>
						模拟+堆+链表+贪心+最小生成树+倍增LCA 这次题目简单了许多……然而蒟蒻还是傻逼了……sad连NOIP题都做这么烂……没救了 File 给定一些目录&amp;文件,让按给定格式输出一个文件列表 其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02R82n0.html" rel="bookmark" class="title">便宜的丰胸产品（专家Q：541858080）</a>
					<div>
						对于胸部,不同的女人有不同的烦恼,关于丰胸,不同的女人有不同的缘由.原因不一样:有的是青春期胸部发育不良想要促进发育,有的是因为胸部成型后仍然偏小,有的是产后ru房下垂.松弛,目的不一样:有的是为了让 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
